#include "chip.h"
#include <stdlib.h>

typedef struct {
    t_chip_per_id id;
    __IO uint32_t *clk_reg;
    uint32_t clk_bit;
    __IO uint32_t *rst_reg;
    uint32_t rst_bit;
} t_per_regs;


static const t_per_regs f_per_regs[] = {
    {CHIP_PER_ID_FLASH,     &CHIP_REGS_RCC->AHBENR,     CHIP_REGFLD_RCC_AHBENR_FLASHEN,     &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_FLASHRST},
    {CHIP_PER_ID_PWR,       &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_PWREN,      &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_PWRRST},
    {CHIP_PER_ID_SYSCFG,    &CHIP_REGS_RCC->APBENR2,    CHIP_REGFLD_RCC_APBENR2_SYSCFGEN,   &CHIP_REGS_RCC->APBRSTR2,   CHIP_REGFLD_RCC_APBRSTR2_SYSCFGRST},
    {CHIP_PER_ID_DBG,       &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_DBGEN ,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_DBGRST},
    {CHIP_PER_ID_GPIOA,     &CHIP_REGS_RCC->IOPENR,     CHIP_REGFLD_RCC_IOPENR_GPIOAEN,     &CHIP_REGS_RCC->IOPRSTR,    CHIP_REGFLD_RCC_IOPRSTR_GPIOARST},
    {CHIP_PER_ID_GPIOB,     &CHIP_REGS_RCC->IOPENR,     CHIP_REGFLD_RCC_IOPENR_GPIOBEN,     &CHIP_REGS_RCC->IOPRSTR,    CHIP_REGFLD_RCC_IOPRSTR_GPIOBRST},
    {CHIP_PER_ID_GPIOC,     &CHIP_REGS_RCC->IOPENR,     CHIP_REGFLD_RCC_IOPENR_GPIOCEN,     &CHIP_REGS_RCC->IOPRSTR,    CHIP_REGFLD_RCC_IOPRSTR_GPIOCRST},
    {CHIP_PER_ID_GPIOD,     &CHIP_REGS_RCC->IOPENR,     CHIP_REGFLD_RCC_IOPENR_GPIODEN,     &CHIP_REGS_RCC->IOPRSTR,    CHIP_REGFLD_RCC_IOPRSTR_GPIODRST},
#if CHIP_DEV_SUPPORT_PORTE
    {CHIP_PER_ID_GPIOE,     &CHIP_REGS_RCC->IOPENR,     CHIP_REGFLD_RCC_IOPENR_GPIOEEN,     &CHIP_REGS_RCC->IOPRSTR,    CHIP_REGFLD_RCC_IOPRSTR_GPIOERST},
#endif
    {CHIP_PER_ID_GPIOF,     &CHIP_REGS_RCC->IOPENR,     CHIP_REGFLD_RCC_IOPENR_GPIOFEN,     &CHIP_REGS_RCC->IOPRSTR,    CHIP_REGFLD_RCC_IOPRSTR_GPIOFRST},

    {CHIP_PER_ID_DMA1,      &CHIP_REGS_RCC->AHBENR,     CHIP_REGFLD_RCC_AHBENR_DMA1EN ,     &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_DMA1RST},
#if CHIP_DEV_SUPPORT_DMA2
    {CHIP_PER_ID_DMA2,      &CHIP_REGS_RCC->AHBENR,     CHIP_REGFLD_RCC_AHBENR_DMA2EN ,     &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_DMA2RST},
#endif
    {CHIP_PER_ID_TIM1,      &CHIP_REGS_RCC->APBENR2,    CHIP_REGFLD_RCC_APBENR2_TIM1EN,     &CHIP_REGS_RCC->APBRSTR2,   CHIP_REGFLD_RCC_APBRSTR2_TIM1RST},
    {CHIP_PER_ID_TIM2,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_TIM2EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_TIM2RST},
    {CHIP_PER_ID_TIM3,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_TIM3EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_TIM3RST},
#if CHIP_DEV_SUPPORT_TIM4
    {CHIP_PER_ID_TIM4,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_TIM4EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_TIM4RST},
#endif
#if CHIP_DEV_SUPPORT_TIM6
    {CHIP_PER_ID_TIM6,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_TIM6EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_TIM6RST},
#endif
#if CHIP_DEV_SUPPORT_TIM7
    {CHIP_PER_ID_TIM7,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_TIM7EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_TIM7RST},
#endif
    {CHIP_PER_ID_TIM14,     &CHIP_REGS_RCC->APBENR2,    CHIP_REGFLD_RCC_APBENR2_TIM14EN,    &CHIP_REGS_RCC->APBRSTR2,   CHIP_REGFLD_RCC_APBRSTR2_TIM14RST},
#if CHIP_DEV_SUPPORT_TIM15
    {CHIP_PER_ID_TIM15,     &CHIP_REGS_RCC->APBENR2,    CHIP_REGFLD_RCC_APBENR2_TIM15EN,    &CHIP_REGS_RCC->APBRSTR2,   CHIP_REGFLD_RCC_APBRSTR2_TIM15RST},
#endif
    {CHIP_PER_ID_TIM16,     &CHIP_REGS_RCC->APBENR2,    CHIP_REGFLD_RCC_APBENR2_TIM16EN,    &CHIP_REGS_RCC->APBRSTR2,   CHIP_REGFLD_RCC_APBRSTR2_TIM16RST},
    {CHIP_PER_ID_TIM17,     &CHIP_REGS_RCC->APBENR2,    CHIP_REGFLD_RCC_APBENR2_TIM17EN,    &CHIP_REGS_RCC->APBRSTR2,   CHIP_REGFLD_RCC_APBRSTR2_TIM17RST},
    {CHIP_PER_ID_LPTIM1,    &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_LPTIM1EN,   &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_LPTIM1RST},
    {CHIP_PER_ID_LPTIM2,    &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_LPTIM2EN,   &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_LPTIM2RST},
    {CHIP_PER_ID_USART1,    &CHIP_REGS_RCC->APBENR2,    CHIP_REGFLD_RCC_APBENR2_USART1EN,   &CHIP_REGS_RCC->APBRSTR2,   CHIP_REGFLD_RCC_APBRSTR2_USART1RST},
    {CHIP_PER_ID_USART2,    &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_USART2EN,   &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_USART2RST},
#if CHIP_DEV_SUPPORT_USART3
    {CHIP_PER_ID_USART3,    &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_USART3EN,   &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_USART3RST},
#endif
#if CHIP_DEV_SUPPORT_USART4
    {CHIP_PER_ID_USART4,    &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_USART4EN,   &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_USART4RST},
#endif
#if CHIP_DEV_SUPPORT_USART5
    {CHIP_PER_ID_USART5,    &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_USART5EN,   &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_USART5RST},
#endif
#if CHIP_DEV_SUPPORT_USART6
    {CHIP_PER_ID_USART6,    &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_USART6EN,   &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_USART6RST},
#endif
    {CHIP_PER_ID_LPUART1,   &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_LPUART1EN,  &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_LPUART1RST},
#if CHIP_DEV_SUPPORT_LPUART2
    {CHIP_PER_ID_LPUART2,   &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_LPUART2EN,  &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_LPUART2RST},
#endif

    {CHIP_PER_ID_SPI1,      &CHIP_REGS_RCC->APBENR2,    CHIP_REGFLD_RCC_APBENR2_SPI1EN,     &CHIP_REGS_RCC->APBRSTR2,   CHIP_REGFLD_RCC_APBRSTR2_SPI1RST},
    {CHIP_PER_ID_SPI2,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_SPI2EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_SPI2RST},
#if CHIP_DEV_SUPPORT_SPI3
    {CHIP_PER_ID_SPI3,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_SPI3EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_SPI3RST},
#endif

    {CHIP_PER_ID_I2C1,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_I2C1EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_I2C1RST},
    {CHIP_PER_ID_I2C2,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_I2C2EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_I2C2RST},
#if CHIP_DEV_SUPPORT_I2C3
    {CHIP_PER_ID_I2C3,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_I2C3EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_I2C3RST},
#endif
    {CHIP_PER_ID_ADC,       &CHIP_REGS_RCC->APBENR2,    CHIP_REGFLD_RCC_APBENR2_ADCEN,      &CHIP_REGS_RCC->APBRSTR2,   CHIP_REGFLD_RCC_APBRSTR2_ADCRST},
#if CHIP_DEV_SUPPORT_DAC
    {CHIP_PER_ID_DAC1,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_DAC1EN,     &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_DAC1RST},
#endif
    {CHIP_PER_ID_CRC,       &CHIP_REGS_RCC->AHBENR,     CHIP_REGFLD_RCC_AHBENR_CRCEN,       &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_CRCRST},
#if CHIP_DEV_SUPPORT_AES
    {CHIP_PER_ID_AES,       &CHIP_REGS_RCC->AHBENR,     CHIP_REGFLD_RCC_AHBENR_AESEN,       &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_AESRST},
#endif
#if CHIP_DEV_SUPPORT_RNG
    {CHIP_PER_ID_RNG,       &CHIP_REGS_RCC->AHBENR,     CHIP_REGFLD_RCC_AHBENR_RNGEN,       &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_RNGRST},
#endif
    {CHIP_PER_ID_RTCAPB,    &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_RTCAPBEN,   NULL,                       0},
    {CHIP_PER_ID_WWDG,      &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_WWDGEN,     NULL,                       0},
#if CHIP_DEV_SUPPORT_FDCAN
    {CHIP_PER_ID_FDCAN,     &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_FDCANEN,    &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_FDCANRST},
#endif
#if CHIP_DEV_SUPPORT_USB
    {CHIP_PER_ID_USB,       &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_USBEN,      &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_USBRST},
#endif
#if CHIP_DEV_SUPPORT_CRS
    {CHIP_PER_ID_CRS,       &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_CRSEN,      &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_CRSRST},
#endif
#if CHIP_DEV_SUPPORT_CEC
    {CHIP_PER_ID_CEC,       &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_CECEN,      &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_CECRST},
#endif
#if CHIP_DEV_SUPPORT_UCPD
    {CHIP_PER_ID_UCPD1,     &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_UCPD1EN,    &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_UCPD1RST},
    {CHIP_PER_ID_UCPD2,     &CHIP_REGS_RCC->APBENR1,    CHIP_REGFLD_RCC_APBENR1_UCPD2EN,    &CHIP_REGS_RCC->APBRSTR1,   CHIP_REGFLD_RCC_APBRSTR1_UCPD2RST},
#endif
};


static const t_per_regs *get_per_regs(t_chip_per_id id) {
    const t_per_regs *ret = NULL;
    for (unsigned i = 0; i < sizeof(f_per_regs)/sizeof(f_per_regs[0]); ++i) {
        if (f_per_regs[i].id == id) {
            ret = &f_per_regs[i];
            break;
        }
    }
    return ret;
}

void chip_per_rst(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->rst_reg) {
        *reg->rst_reg |= reg->rst_bit;
        chip_dmb();
        *reg->rst_reg &= ~reg->rst_bit;
        chip_dsb();
    }
}

void chip_per_clk_en(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg)
        *reg->clk_reg |= reg->clk_bit;
}

void chip_per_clk_dis(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg)
        *reg->clk_reg &= ~reg->clk_bit;
}

int chip_per_clk_is_en(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    return  reg && reg->clk_reg && ((*reg->clk_reg & reg->clk_bit) != 0);
}
